<?php

namespace Drupal\pdf_slideshow\Manager;

use Imagick;

/**
 * Class PdfSlideshowImagickManager
 *
 * @package Drupal\pdf_slideshow\Manager
 */
class PdfSlideshowImagickManager {

  /**
   *
   * Generate images from pdf.
   *
   * @param $source
   * @param $target
   *
   * @param int $width
   * @param int $height
   *
   * @param int $limit
   *
   * @return array
   * @throws \ImagickException
   */
  public function generateImage(
    $source,
    $target,
    $width = 200,
    $height = 250,
    $limit = 3
  ) {
    $target = dirname($source) . DIRECTORY_SEPARATOR . $target;
    $im = new Imagick($source);
    $im->setimageformat("png");
    $im->setImageAlphaChannel(Imagick::ALPHACHANNEL_REMOVE);
    $im->mergeImageLayers(Imagick::LAYERMETHOD_FLATTEN);
    $im->setImageBackgroundColor('white');
    $nbImage = $im->getNumberImages();
    $imageFilename = [];
    for ($i = 0; $i < $nbImage && $i < $limit; $i++) {
      $im->setIteratorIndex($i);
      $im->thumbnailimage($width, $height);
      $im->writeImage(str_replace('.png', '-' . $i . '.png', $target));
      $imageFilename[] = $im->getImageFilename();
    }
    $im->clear();
    $im->destroy();
    return $imageFilename;
  }

}